/*
 * ProviewR   Open Source Process Control.
 * Copyright (C) 2005-2019 SSAB EMEA AB.
 *
 * This file is part of ProviewR.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation, either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with ProviewR. If not, see <http://www.gnu.org/licenses/>
 *
 * Linking ProviewR statically or dynamically with other modules is
 * making a combined work based on ProviewR. Thus, the terms and
 * conditions of the GNU General Public License cover the whole
 * combination.
 *
 * In addition, as a special exception, the copyright holders of
 * ProviewR give you permission to, from the build function in the
 * ProviewR Configurator, combine ProviewR with modules generated by the
 * ProviewR PLC Editor to a PLC program, regardless of the license
 * terms of these modules. You may copy and distribute the resulting
 * combined work under the terms of your choice, provided that every
 * copy of the combined work is accompanied by a complete copy of
 * the source code of ProviewR (the version used to produce the
 * combined work), being distributed under the terms of the GNU
 * General Public License plus this exception.
 */

#ifndef pn_viewer_pnac_h
#define pn_viewer_pnac_h

/* pn_viewer_pnac.h -- Profinet viewer PNAC interface */

#include "pn_viewernav.h"

#include "rt_io_base.h"
#include "rt_io_pnak_locals.h"
#include "rt_pn_gsdml_data.h"

class PnViewerPNAC {
public:
  PnViewerPNAC(pwr_tStatus* sts, const char* dev_name);
  ~PnViewerPNAC();

  void fetch_devices(std::vector<PnDevice>& dev_vect);
  void set_device_properties(
      unsigned char* macaddress, unsigned char* ipaddress, char* devname);
  GsdmlDeviceData dev_data;
  io_sAgentLocal* local;
};

#endif
