/*
 * ProviewR   Open Source Process Control.
 * Copyright (C) 2005-2019 SSAB EMEA AB.
 *
 * This file is part of ProviewR.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation, either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with ProviewR. If not, see <http://www.gnu.org/licenses/>
 *
 * Linking ProviewR statically or dynamically with other modules is
 * making a combined work based on ProviewR. Thus, the terms and
 * conditions of the GNU General Public License cover the whole
 * combination.
 *
 * In addition, as a special exception, the copyright holders of
 * ProviewR give you permission to, from the build function in the
 * ProviewR Configurator, combine ProviewR with modules generated by the
 * ProviewR PLC Editor to a PLC program, regardless of the license
 * terms of these modules. You may copy and distribute the resulting
 * combined work under the terms of your choice, provided that every
 * copy of the combined work is accompanied by a complete copy of
 * the source code of ProviewR (the version used to produce the
 * combined work), being distributed under the terms of the GNU
 * General Public License plus this exception.
 */

#ifndef cow_pb_gsd_attr_h
#define cow_pb_gsd_attr_h

/* cow_pb_gsd_attr.h -- Profibus gsd attribute editor */

#include "cow_pb_gsd.h"

typedef struct {
  void* value;
  char name[80];
  int type;
  int size;
  double minlimit;
  double maxlimit;
  int noedit;
  int multiline;
  int mask;
} attr_sItem;

class GsdAttrNav;
class CoWow;

class GsdAttr {
public:
  void* parent_ctx;
  char name[80];
  pb_gsd* gsd;
  int edit_mode;
  GsdAttrNav* attrnav;
  int input_open;
  void* object;
  void (*close_cb)(void*);
  int (*save_cb)(void*);
  int (*help_cb)(void*, const char*);
  void* client_data;
  int recall_idx;
  static char value_recall[30][160];
  int value_current_recall;
  CoWow* wow;

  GsdAttr(void* a_parent_ctx, void* a_object, pb_gsd* a_gsd, int a_edit_mode);
  virtual ~GsdAttr();

  virtual void message(char severity, const char* message) {}
  virtual void set_prompt(const char* prompt) {}
  virtual void change_value() {}

  void activate_exit();
  void activate_help();
  void activate_copy();
  void activate_cut();
  void activate_paste();
  void activate_print();
  void activate_zoom_in();
  void activate_zoom_out();
  void activate_zoom_reset();
  void activate_cmd_ok();
  void activate_cmd_apply();
  void activate_cmd_ca();

  static void gsdattr_message(void* attr, char severity, const char* message);
  static void gsdattr_change_value_cb(void* attr_ctx);
  static void cmd_close_apply_cb(void* ctx, void* data);
  static void cmd_close_no_cb(void* ctx, void* data);
};

#endif
