/*
 * ProviewR   Open Source Process Control.
 * Copyright (C) 2005-2019 SSAB EMEA AB.
 *
 * This file is part of ProviewR.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation, either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with ProviewR. If not, see <http://www.gnu.org/licenses/>
 *
 * Linking ProviewR statically or dynamically with other modules is
 * making a combined work based on ProviewR. Thus, the terms and
 * conditions of the GNU General Public License cover the whole
 * combination.
 *
 * In addition, as a special exception, the copyright holders of
 * ProviewR give you permission to, from the build function in the
 * ProviewR Configurator, combine ProviewR with modules generated by the
 * ProviewR PLC Editor to a PLC program, regardless of the license
 * terms of these modules. You may copy and distribute the resulting
 * combined work under the terms of your choice, provided that every
 * copy of the combined work is accompanied by a complete copy of
 * the source code of ProviewR (the version used to produce the
 * combined work), being distributed under the terms of the GNU
 * General Public License plus this exception.
 */
/*****************************************************************************/
/*                                                                           */
/*                               SOFTING AG                                  */
/*                        Richard-Reitzner-Allee 6                           */
/*                              D-85540 Haar                                 */
/*                      Phone: (++49)-(0)89-45656-0                          */
/*                      Fax:   (++49)-(0)89-45656-399                        */
/*                                                                           */
/*                    Copyright (C) SOFTING AG 1995-2003                     */
/*                            All Rights Reserved                            */
/*                                                                           */
/*****************************************************************************/
/*****************************************************************************/
/*                       PROFIBUS WINDOWS NT DRIVERS                         */
/*                                                                           */
/*  Filename    : PB_NTDRV.H                                                 */
/*  Version     : 5.26.0.01.release                                          */
/*  Date        : 30-April-2003                                              */
/*  Author      : SOFTING AG                                                 */
/*                                                                           */
/*  Description : This file contains the global declarations                 */
/*                to access the PROFIBUS Drivers for Windows NT              */
/*                                                                           */
/*****************************************************************************/

#ifndef _PB_NTDRV_H_
#define _PB_NTDRV_H_

#ifndef CTL_CODE
#include "winioctl.h"
#endif

/*****************************************************************************/
/* Definitions of IO Control codes                                           */
/*****************************************************************************/

#define FILE_DEVICE_PROFIBOARD 0x8000

#define IOCTL_PROFI_CREATE_DP_MANAGEMENT                                       \
  (ULONG) CTL_CODE(                                                            \
      FILE_DEVICE_PROFIBOARD, 0x800, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_PROFI_CREATE_DP_SERVICE                                          \
  (ULONG) CTL_CODE(                                                            \
      FILE_DEVICE_PROFIBOARD, 0x801, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_PROFI_CREATE_DP_SLAVE_DATA                                       \
  (ULONG) CTL_CODE(                                                            \
      FILE_DEVICE_PROFIBOARD, 0x802, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_PROFI_CREATE_FDL_MANAGEMENT                                      \
  (ULONG) CTL_CODE(                                                            \
      FILE_DEVICE_PROFIBOARD, 0x803, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_PROFI_CREATE_FDL_SAP                                             \
  (ULONG) CTL_CODE(                                                            \
      FILE_DEVICE_PROFIBOARD, 0x804, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_PROFI_CREATE_FMS_MANAGEMENT                                      \
  (ULONG) CTL_CODE(                                                            \
      FILE_DEVICE_PROFIBOARD, 0x805, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_PROFI_CREATE_FMS_CR                                              \
  (ULONG) CTL_CODE(                                                            \
      FILE_DEVICE_PROFIBOARD, 0x806, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_PROFI_CREATE_DP_MSAC                                             \
  (ULONG) CTL_CODE(                                                            \
      FILE_DEVICE_PROFIBOARD, 0x80e, METHOD_BUFFERED, FILE_ANY_ACCESS)

#define IOCTL_PROFI_SET_TIMEOUT                                                \
  (ULONG) CTL_CODE(                                                            \
      FILE_DEVICE_PROFIBOARD, 0x808, METHOD_BUFFERED, FILE_READ_ACCESS)
#define IOCTL_PROFI_GET_TIMEOUT                                                \
  (ULONG) CTL_CODE(                                                            \
      FILE_DEVICE_PROFIBOARD, 0x809, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_PROFI_SET_QUEUE_SIZE                                             \
  (ULONG) CTL_CODE(                                                            \
      FILE_DEVICE_PROFIBOARD, 0x80a, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_PROFI_GET_QUEUE_SIZE                                             \
  (ULONG) CTL_CODE(                                                            \
      FILE_DEVICE_PROFIBOARD, 0x80b, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_PROFI_GET_OVERRUN_COUNT                                          \
  (ULONG) CTL_CODE(                                                            \
      FILE_DEVICE_PROFIBOARD, 0x80c, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_PROFI_READ_MULTI                                                 \
  (ULONG) CTL_CODE(                                                            \
      FILE_DEVICE_PROFIBOARD, 0x80d, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_PROFI_GET_DATA_IMAGE                                             \
  (ULONG) CTL_CODE(                                                            \
      FILE_DEVICE_PROFIBOARD, 0x80f, METHOD_BUFFERED, FILE_ANY_ACCESS)

#define IOCTL_PROFI_SET_DPS_DATA                                               \
  (ULONG) CTL_CODE(                                                            \
      FILE_DEVICE_PROFIBOARD, 0x810, METHOD_IN_DIRECT, FILE_ANY_ACCESS)

#define IOCTL_PROFI_SET_DP_BITS                                                \
  (ULONG) CTL_CODE(                                                            \
      FILE_DEVICE_PROFIBOARD, 0x811, METHOD_BUFFERED, FILE_WRITE_ACCESS)
#define IOCTL_PROFI_CLEAR_DP_BITS                                              \
  (ULONG) CTL_CODE(                                                            \
      FILE_DEVICE_PROFIBOARD, 0x812, METHOD_BUFFERED, FILE_WRITE_ACCESS)

#define IOCTL_PROFI_CHECK_DEV_CONN                                             \
  (ULONG) CTL_CODE(                                                            \
      FILE_DEVICE_PROFIBOARD, 0x813, METHOD_BUFFERED, FILE_ANY_ACCESS)

/*****************************************************************************/
/* Macros to access for PROFIBUS specific error codes                        */
/*****************************************************************************/

#define PROFI_ERROR_FLAG 0xe0000000

#define CUSTOMER_OK_FLAG 0x20000000 // Bit 29 set
#define CUSTOMER_ERROR_FLAG 0xe0000000 // Bit 29..31 set

#define PROFI_ERROR(code) ((code) | PROFI_ERROR_FLAG)
#define PROFI_ERROR_FLAG_SET(code) ((BOOL)(((code)&PROFI_ERROR_FLAG) != 0))

#define CUSTOMER_FLAG_SET(code) ((BOOL)((code)&CUSTOMER_OK_FLAG))

/*****************************************************************************/
/* Timeout structure and define for infinitive wait                          */
/*****************************************************************************/

#define WAIT_FOREVER ((ULONG)-1)

typedef struct _PROFI_TIMEOUT {
  ULONG TimeoutRead;
  ULONG TimeoutWrite;
} PROFI_TIMEOUT, T_PROFI_TIMEOUT;

/*****************************************************************************/
/* Structure for data image description                                      */
/*****************************************************************************/

typedef struct _PROFI_DATA_IMAGE_DESCR {
  UCHAR imageId;
  USHORT offset;
  UCHAR bus;
} PROFI_DATA_IMAGE_DESCR, T_PROFI_DATA_IMAGE_DESCR;

/*****************************************************************************/
/* Structure for bit access in DP output data                                */
/*****************************************************************************/

typedef struct _PROFI_DP_BIT_ACCESS {
  USHORT offset;
  UCHAR mask;
} PROFI_DP_BIT_ACCESS, T_PROFI_DP_BIT_ACCESS;

/*****************************************************************************/
/* Definitions for system registry access                                    */
/*****************************************************************************/

#define REGPATH_PARAMETER_FROM_HLM                                             \
  "SYSTEM\\CurrentControlSet\\Services\\PROFIbrd\\Parameters"
#define MAX_SYMBOLIC_LINK_NAME_SIZE 255

/*****************************************************************************/
/* Operation Mode as (FMS/DPV1-Master or DP-Slave)                           */
/*****************************************************************************/

#define FMS_DPV1_MASTER_MODE 0x00 // FMS/DPV1-Master
#define DPV1_MASTER_MODE 0x01 // for future use
#define DPV1_SLAVE_MODE 0x02 // DP-Slave

#endif
