/*
 * ProviewR   Open Source Process Control.
 * Copyright (C) 2005-2019 SSAB EMEA AB.
 *
 * This file is part of ProviewR.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation, either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with ProviewR. If not, see <http://www.gnu.org/licenses/>
 *
 * Linking ProviewR statically or dynamically with other modules is
 * making a combined work based on ProviewR. Thus, the terms and
 * conditions of the GNU General Public License cover the whole
 * combination.
 *
 * In addition, as a special exception, the copyright holders of
 * ProviewR give you permission to, from the build function in the
 * ProviewR Configurator, combine ProviewR with modules generated by the
 * ProviewR PLC Editor to a PLC program, regardless of the license
 * terms of these modules. You may copy and distribute the resulting
 * combined work under the terms of your choice, provided that every
 * copy of the combined work is accompanied by a complete copy of
 * the source code of ProviewR (the version used to produce the
 * combined work), being distributed under the terms of the GNU
 * General Public License plus this exception.
 */

#ifndef wb_c_pb_dp_slave_h
#define wb_c_pb_dp_slave_h

#include "wb_ldh.h"

#include "cow_pb_gsd_attr.h"

/* wb-c_pb_dp_slave.h -- Profibus gsd configure method */

typedef struct {
  pb_gsd* gsd;
  GsdAttr* attr;
  ldh_tSession ldhses;
  pwr_tAttrRef aref;
  gsd_sModuleClass* mc;
  void* editor_ctx;
  int edit_mode;
} slave_sCtx;

pwr_tStatus pb_dp_slave_create_ctx(ldh_tSession ldhses, pwr_tAttrRef aref,
    void* editor_ctx, slave_sCtx** ctxp);
int pb_dp_slave_help_cb(void* sctx, const char* text);
void pb_dp_slave_close_cb(void* sctx);
int pb_dp_slave_save_cb(void* sctx);

#endif
