/*
 * ProviewR   Open Source Process Control.
 * Copyright (C) 2005-2019 SSAB EMEA AB.
 *
 * This file is part of ProviewR.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation, either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with ProviewR. If not, see <http://www.gnu.org/licenses/>
 *
 * Linking ProviewR statically or dynamically with other modules is
 * making a combined work based on ProviewR. Thus, the terms and
 * conditions of the GNU General Public License cover the whole
 * combination.
 *
 * In addition, as a special exception, the copyright holders of
 * ProviewR give you permission to, from the build function in the
 * ProviewR Configurator, combine ProviewR with modules generated by the
 * ProviewR PLC Editor to a PLC program, regardless of the license
 * terms of these modules. You may copy and distribute the resulting
 * combined work under the terms of your choice, provided that every
 * copy of the combined work is accompanied by a complete copy of
 * the source code of ProviewR (the version used to produce the
 * combined work), being distributed under the terms of the GNU
 * General Public License plus this exception.
 */

#ifndef wb_c_pndevice_h
#define wb_c_pndevice_h

#include "wb_ldh.h"

#include "cow_pn_gsdml_attr.h"

/* wb_c_pndevice.h -- Profinet gsdml configure method */

typedef struct {
  pn_gsdml* gsdml;
  GsdmlAttr* attr;
  ldh_tSession ldhses;
  pwr_tAttrRef aref;
  gsdml_sModuleClass* mc;
  void* editor_ctx;
  int edit_mode;
} device_sCtx;

pwr_tStatus pndevice_create_ctx(ldh_tSession ldhses, pwr_tAttrRef aref,
    void* editor_ctx, device_sCtx** ctxp);
pwr_tStatus pndevice_init(device_sCtx* ctx);
int pndevice_help_cb(void* sctx, const char* text);
void pndevice_close_cb(void* sctx);
int pndevice_save_cb(void* sctx);
pwr_tStatus pndevice_postcopy( ldh_tSesContext Session, pwr_tOid Object, 
    pwr_tOid Source, pwr_tCid Class);


#endif
